
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【Simplify Path】cpp / 憋错料</title>

    <meta name="description" content="【Simplify Path】cpp 题目: Given an absolute path for a file (Unix-style), simplify it. For example,path = &quot;/home/&quot;, =&gt; &quot;/home&quot;path = &quot;/a/./b/../../c/&quot;, =&gt; &quot;/c&quot; click to show corner cases. Corner Cases: Did you consider the cas ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">【Simplify Path】cpp</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>题目：</p>
<p>Given an absolute path for a file (Unix-style), simplify it.</p>
<p>For example,<br />path&nbsp;=&nbsp;<code>"/home/"</code>, =&gt;&nbsp;<code>"/home"</code><br />path&nbsp;=&nbsp;<code>"/a/./b/../../c/"</code>, =&gt;&nbsp;<code>"/c"</code></p>
<p><a href="https://leetcode.com/problems/simplify-path/" rel="external nofollow noreferrer">click to show corner cases.</a></p>
<p>Corner Cases:</p>
<ul>
<li>Did you consider the case where&nbsp;path&nbsp;=&nbsp;<code>"/../"</code>?<br />In this case, you should return&nbsp;<code>"/"</code>.</li>
<li>Another corner case is the path might contain multiple slashes&nbsp;<code>‘/‘</code>&nbsp;together, such as&nbsp;<code>"/home//foo/"</code>.<br />In this case, you should ignore redundant slashes and return&nbsp;<code>"/home/foo"</code>.</li>
</ul>
<p>代码：</p>
<pre>class Solution {
public:
    string simplifyPath(string path) {
            string result = "";
            path.append("/"); // some input path not end with "/"
            vector&lt;string&gt; ret; // use vector acting as stack
            string tmp_part = "";
            ret.push_back(string(1,path[0]));
            for ( size_t i = 1; i &lt; path.size(); ++i ){
                if ( path[i]==‘/‘ ){
                    if ( tmp_part==".." ){
                        if ( ret.size()&gt;1 )
                        {
                            ret.erase(ret.end()-1);
                            ret.erase(ret.end()-1);
                        }
                    }
                    else
                    {
                        if ( tmp_part!="" &amp;&amp; tmp_part!="." )
                        {
                            ret.push_back(tmp_part);
                            ret.push_back("/");
                        }
                    }
                    tmp_part = "";
                }
                else
                {
                    tmp_part += path[i];
                }
            }
            if ( ret.size()&gt;1 &amp;&amp; ret[ret.size()-1]=="/" ) ret.erase(ret.end()-1);
            for ( size_t i = 0; i &lt; ret.size(); ++i ) result += ret[i];
            return result;
    }
};</pre>
<p>tips:</p>
<p>主要思想是stack堆栈的数据结构。</p>
<p>1. 利用"/"来作为间隔判断符号</p>
<p>2. tmp_part为两个"/"之间的字符串部分（需要注意输入的path可能不以"/"结尾，解决办法是人工在path后面补上一个）</p>
<p>3. 如果tmp_part为&ldquo;..&rdquo;，则出栈两个元素（前提是栈中元素数目足够）</p>
<p>如果tmp_part不为&ldquo;.&rdquo;, 且不为"."，且不为"", 则入栈（注意，还要包括后面的&ldquo;/&rdquo;）</p>
<p>其他部分靠题目提供的一些corner cases来debug了。</p>
<p>这里用到的一个技巧是vector来代替stack；这样做的好处是返回结果时不用将stack的元素倒序组合。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 19:09:48 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>【Simplify Path】cpp的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmG8On3.html" rel="bookmark">【Word Break】cpp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: Given a string s and a dictionary of words dict, determine if s can be segmented into a space-separated sequence of one or more dictionary words. For example, givens = &quot;leetcode&quot;,dict = [&quot;leet&quot;, &quot;code&quot;]. Return true becau			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YgmvW4.html" rel="bookmark">【Sudoku Solver】cpp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: Write a program to solve a Sudoku puzzle by filling the empty cells. Empty cells are indicated by the character '.'. You may assume that there will be only one unique solution. A sudoku puzzle... ...and its solution numbers marked in red. 代码: cla			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02bgPB0.html" rel="bookmark">【Subsets II】cpp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: Given a collection of integers that might contain duplicates, nums, return all possible subsets. Note: Elements in a subset must be in non-descending order. The solution set must not contain duplicate subsets. For example,If nums = [1,2,2], a sol			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n1pzVM.html" rel="bookmark">【LRU Cache】cpp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: Design and implement a data structure for Least Recently Used (LRU) cache. It should support the following operations: get and set. get(key) - Get the value (will always be positive) of the key if the key exists in the cache, otherwise return -1.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3wrqnR0.html" rel="bookmark">【Rotate List】cpp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: Given a list, rotate the list to the right by k places, where k is non-negative. For example:Given 1-&gt;2-&gt;3-&gt;4-&gt;5-&gt;NULL and k = 2,return 4-&gt;5-&gt;1-&gt;2-&gt;3-&gt;NULL. 代码: /** * Definition for singly-linked list. * struct ListNode {			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoGQkwM.html" rel="bookmark">【Text Justification】cpp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: Given an array of words and a length L, format the text such that each line has exactly L characters and is fully (left and right) justified. You should pack your words in a greedy approach; that is, pack as many words as you can in each line. Pa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NzzBG4.html" rel="bookmark">【Implement strStr&lpar;&rpar; 】cpp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: Implement strStr(). Returns the index of the first occurrence of needle in haystack, or -1 if needle is not part of haystack. Update (2014-11-02):The signature of the function had been updated to return the index instead of the pointer. If you st			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35lloj0.html" rel="bookmark">【Valid Palindrome】cpp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: Given a string, determine if it is a palindrome, considering only alphanumeric characters and ignoring cases. For example,&quot;A man, a plan, a canal: Panama&quot; is a palindrome.&quot;race a car&quot; is not a palindrome. Note:Have you consider tha			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgPzAO0.html" rel="bookmark">【Jump Game】cpp</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题目: Given an array of non-negative integers, you are initially positioned at the first index of the array. Each element in the array represents your maximum jump length at that position. Determine if you are able to reach the last index. For example:			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/pMPJPB3.html" rel="bookmark" class="title">HDU-4438 Hunters 期望 水</a>
					<div>
						最近在复习概率DP求期望,顺便做一下. 分成第二个人选择老虎或者狼的情况. 然后 s1+=q*(p)*(p)*(x+y)+q*p*(1-p)*x+q*(1-p)*p*y;//老虎 且第一个人选择老虎的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r4Jedb3.html" rel="bookmark" class="title">Maven国内下载站点</a>
					<div>
						鉴于一些原因,从maven中央仓库download依赖包时,被各种折磨,下面就简单看下maven setting.xml的一些简单配置 先贴几个国内可用的maven repository连接: htt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz876O3.html" rel="bookmark" class="title">ffmpeg文档25-设备选项</a>
					<div>
						25 设备选项 libavdevice库提供类似libavformat的接口,即一个输入设备被认为类似一个分离器活着输出设备类似一个混合器.这些接口也类似libavformat一样提供一些常规设备选项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8Vrl3.html" rel="bookmark" class="title">利用MVVM设计快速开发个人中心、设置等模块</a>
					<div>
						我们在做iOS开发过程中,静态页面的开发比开发动态页面更让我们开发者抓狂.因为动态页面通常是一个页面一种cell样式,作为开发者只需要专注于定制好一种样式之后,就可以使用数据填充出较好的界面.而静态c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YYryy0.html" rel="bookmark" class="title">SD卡里&period;android&lowbar;secure该不该删的</a>
					<div>
						建议***一些不必要的垃圾文件: 把你不清楚的文件夹都***掉就行了,既节省空间又能保证软件稳定性,你知道的比如Camera.Ringtones.Recorder.Photo. Music.Backu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5RdN3.html" rel="bookmark" class="title">第六百零六天 how can I 坚持（应该是六百零六天吧）</a>
					<div>
						找了个考研的借口,也是挺逗的,终于结束了,而且考的很渣. 最近发生了很多事,很快就要离开泛华了,放弃安逸,开始改变吧,其实感觉自己内心挺怂的,很怕改变,哎,这不像是有梦想,能成事的人应该有的. 还是想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEvpjy0.html" rel="bookmark" class="title">win10 到底好吗？Win7&sol;Win10系统全面对比评测</a>
					<div>
						历经9个月数百万人内测完善之后,微软终于发布Win10正式版系统.但是可能对于部分用户而言,Win7仍然是绝对的经典.游戏玩家的不二之选,为何非要升级到Win10系统呢?Windows10性能和功能相 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDrld83.html" rel="bookmark" class="title">Lists of network protocols</a>
					<div>
						https://en.wikipedia.org/wiki/Lists_of_network_protocols Protocol stack: List of network protocol st ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOA8J0.html" rel="bookmark" class="title">ueditor使用注意事项</a>
					<div>
						1.js问题的介绍 第一ueditor型材 &lt;script type=&quot;text/javascript&quot; src=&quot;ueditor1_4_3-utf8-jsp/ue ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j1OeoM.html" rel="bookmark" class="title">HTML5 Audio and Video 的新属性简介</a>
					<div>
						前言:HTML5 中 Audio and Video的使用方法比较简单,但就是比较复杂,方法属性多.如果不常用的几乎难以记住,甚至有些人难以区分不同属性和方法的作用,更别说应用了.以下对Audio a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODArX4.html" rel="bookmark" class="title">Spring 配置文件错误</a>
					<div>
						错误解决:    springmvc的头部标识写错. 情况是这样的: 1 2 3 4 5 &lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOlVK0.html" rel="bookmark" class="title">worktools-git 工具的使用总结（2）</a>
					<div>
						1.创建分支 //创建分支,是在master 分支的基础上创建 [email protected]-MS-7817:~/myGit$ git st # On branch master nothing ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOm6K0.html" rel="bookmark" class="title">在现有xp系统下安装win7系统记（需两块硬盘操作）</a>
					<div>
						问题: 1.用户现有系统为xp系统,3个有数据内容的分区.在现有基础上加win7系统 答: 思路: 1.在PE下利用DiskGenius工具将D盘划分出两个分区D.G,将win7镜像还原到G分区. 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXng8Q3.html" rel="bookmark" class="title">移动前端开发之数据库操作篇</a>
					<div>
						在移动平台开发中,经常会有大数据存储与交互的操作,在以webkit为内核的浏览器中,提供了一个叫作WEBSQL的数据库.这让我们前端也可以像php等程序语言一样,进行数据库的读写操作.Web Stor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jeaJ7M.html" rel="bookmark" class="title">Objective-C中的类目，延展，协议</a>
					<div>
						Objective-C中的类目(Category),延展(Extension),协议(Protocol)这些名词看起来挺牛的,瞬间感觉OC好高大上.在其他OOP语言中就没见过这些名词,刚看到这三个名词 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvWKD3.html" rel="bookmark" class="title">监听Android的Home键碰到的问题</a>
					<div>
						Android的TV监听Home键切换信源碰到的问题 实现的功能是按下Home键,焦点放到TV小窗口上,再次按下Home键,切换信源,进入另一个信源.在另一个信源的显示下,按下Home键,原信源视图缩 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBWROJ0.html" rel="bookmark" class="title">DNS and Bind （二）</a>
					<div>
						概述: 本篇为DNS服务器内容的第二部分主要介绍了从DNS服务器的配置,子域授权,转发服务器等相关内容 ================================================ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmnL9M.html" rel="bookmark" class="title">Lync Server 2013 部署 &lowbar; Lync Server 边缘高可用（DNS轮询）</a>
					<div>
						公网发布离不开边缘服务器,和前端一样,边缘服务器也需要高可用的架构 可以通过硬件负载平衡器和DNS轮询实现,我们用DNS轮询实现,但是外网发布的话需要两个公网地址,作为演示我就发布一台 部署内容如下: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pNbq80.html" rel="bookmark" class="title">c&plus;&plus; primer 10 关联容器</a>
					<div>
						关联容器和顺序容器的本质差别在于:关联容器通过键(key)存储和读取元素,顺序容器则通过元素在容器中的位置顺序存储和访问元素 关联容器类型 map 关联数组:元素通过键来存储和读取 set 大小可变的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBjgLKM.html" rel="bookmark" class="title">IMAGE&lowbar;TEST</a>
					<div>
											</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
